function varargout = Dicot(varargin)
% DICOT MATLAB code for Dicot.fig
%      DICOT, by itself, creates a new DICOT or raises the existing
%      singleton*.
%
%      H = DICOT returns the handle to a new DICOT or the handle to
%      the existing singleton*.
%
%      DICOT('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in DICOT.M with the given input arguments.
%
%      DICOT('Property','Value',...) creates a new DICOT or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before Dicot_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to Dicot_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help Dicot

% Last Modified by GUIDE v2.5 17-Mar-2015 11:55:13

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Dicot_OpeningFcn, ...
                   'gui_OutputFcn',  @Dicot_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before Dicot is made visible.
function Dicot_OpeningFcn(hObject, eventdata, h, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to Dicot (see VARARGIN)

% Choose default command line output for Dicot
h.output = hObject;

% ROOTS
if ~isempty(varargin)
    h.parameters=varargin{1};
else % default parameters
    tap = struct('r',1.5,'a',0.2,'theta',0,'lb',2,'la',15,'ln',1,'nob',30,'dx',0.25,...
        'color',[0.5,0,0],'tropism',[1,1.5,0.2],'successor',2,'rlt',Inf,'gf',1,...
        'name','Tap root');
    lateral = struct('r',2,'a',0.1,'theta',70/180*pi,'lb',4,'la',5,'ln',2,'nob',7,'dx',0.25,...
        'color',[0,1,0],'tropism',[1,1,0.3],'successor',[],'rlt',Inf,'gf',1,...
        'name','Lateral');
    lateral2 = struct('r',1,'a',0.07,'theta',70/180*pi,'lb',0,'la',2,'ln',1,'nob',0,'dx',0.25,...
        'color',[0.5,0.5,0],'tropism',[1,0,0.4],'successor',[],'rlt',Inf,'gf',1,...
        'name','Second order lateral');
    basal = tap;
    basal.name = 'Basal root';
    basal.tropism = [1,1,0.2];
    basal.theta = 80/180*pi;
    basal.color = [0.5,0,0.5];
    h.parameters = {tap, lateral, lateral2, basal};
end

% PLANT
h.plantingdepth = str2double(get(h.edit4,'String'));
h.firstB = str2num(get(h.edit10,'String'));
h.delayB = str2num(get(h.edit11,'String'));
h.maxB = str2double(get(h.edit12,'String'));

% SIMULATION
h.simtime = str2double(get(h.edit2,'String')); % days
h.intermediate = str2double(get(h.edit3,'String'));

% Legend
im = imread('smalldicot.png');
axes(h.axes1);
imshow(im);

% Update handles structure
guidata(hObject, h);

% UIWAIT makes Dicot wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = Dicot_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% --- Executes on button press in checkbox5.
function checkbox5_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if get(hObject,'Value') 
    set(handles.pushbutton2,'Enable','on');
else
    set(handles.pushbutton2,'Enable','off');
end
    
% --- Executes on button press in checkbox6.
function checkbox6_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if get(hObject,'Value') 
    set(handles.pushbutton3,'Enable','on');
else
    set(handles.pushbutton3,'Enable','off');
end

% Basal roots
function checkbox7_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if get(hObject,'Value')     
    set(handles.checkbox9,'Enable','on');    
    if get(handles.checkbox9,'Value')
        set(handles.pushbutton4,'Enable','off');
    else
        set(handles.pushbutton4,'Enable','on');
    end
    set(handles.text20,'Enable','on');
    set(handles.text21,'Enable','on');
    set(handles.text22,'Enable','on');
    set(handles.text23,'Enable','on');
    set(handles.edit10,'Enable','on');    
    set(handles.edit11,'Enable','on');  
    set(handles.edit12,'Enable','on');   
else
    set(handles.pushbutton4,'Enable','off');
    set(handles.checkbox9,'Enable','off');    
    set(handles.text20,'Enable','off');
    set(handles.text21,'Enable','off');
    set(handles.text22,'Enable','off');
    set(handles.text23,'Enable','off');  
    set(handles.edit10,'Enable','off');    
    set(handles.edit11,'Enable','off');  
    set(handles.edit12,'Enable','off');       
end

% --- Executes on button press in checkbox9.
function checkbox9_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if get(handles.checkbox9,'Value')
    set(handles.pushbutton4,'Enable','off');
else
    set(handles.pushbutton4,'Enable','on');
end



% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.parameters{1} = rootparamUI(handles.parameters{1},'tap');
guidata(hObject,handles);

% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.parameters{2} = rootparamUI(handles.parameters{2});
guidata(hObject,handles);

% --- Executes on button press in pushbutton3.
function pushbutton3_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.parameters{3} = rootparamUI(handles.parameters{3},'nobranches');
guidata(hObject,handles);

% --- Executes on button press in pushbutton4.
function pushbutton4_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.parameters{4} = rootparamUI(handles.parameters{4});
guidata(hObject,handles);

% --- Executes on button press in pushbutton6.
function pushbutton6_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)




% save .m file 
function pushbutton7_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

h=handles;
[filename, pathname] = uiputfile({'*.m'},'Save as');
if ~(isequal(filename,0) || isequal(pathname,0)) % not cancel

    % load template
    load('template.mat');
    
    % define successors
    p = h.parameters;
    [h,p] = setSuccessors(h,p);    
    p = completeParameters(p); % check parameters

    fid = fopen(fullfile(pathname,filename),'w');
    
    fprintf(fid,pre);
    
    if isempty(p{1}.successor)
        sstr = '[]';
    else
        sstr = ['[', num2str(p{1}.successor(1)), ', 1]'];
    end
    
    fprintf(fid,tap,p{1}.r(1),p{1}.r(2),p{1}.a(1),p{1}.a(2),p{1}.lb(1),...
        p{1}.lb(2),p{1}.la(1),p{1}.la(2),p{1}.ln(1),p{1}.ln(2),p{1}.nob(1),p{1}.nob(2),...
        p{1}.name,p{1}.color(1), p{1}.color(2),p{1}.color(3),...
        p{1}.tropism(1),p{1}.tropism(2),p{1}.tropism(3),...
        p{1}.dx(1), p{1}.rlt(1),p{1}.rlt(2),p{1}.gf(1),sstr); % Tap root

    if get(h.checkbox5,'Value')==1 % Lateral
        if isempty(p{2}.successor)
            sstr = '[]';
        else
            sstr = ['[', num2str(p{2}.successor(1)), ', 1]'];
        end
        fprintf(fid,lateral,p{2}.r(1),p{2}.r(2),p{2}.a(1),p{2}.a(2),...
            p{2}.theta(1),p{2}.theta(2),p{2}.lb(1),p{2}.lb(2), p{2}.la(1),...
            p{2}.la(2), p{2}.ln(1), p{2}.ln(2),p{2}.nob(1), p{2}.nob(2),...
            p{2}.name,p{2}.color(1), p{2}.color(2),p{2}.color(3),...
            p{2}.tropism(1),p{2}.tropism(2),p{2}.tropism(3),...
            p{2}.dx(1), p{2}.rlt(1),p{2}.rlt(2),p{2}.gf(1),sstr);
    end
    
    if get(h.checkbox6,'Value')==1 % Second order lateral
        fprintf(fid,lateral2,p{3}.r(1),p{3}.r(2),p{3}.a(1),p{3}.a(2),...
            p{3}.theta(1),p{3}.theta(2),p{3}.la(1),p{3}.la(2),...        
            p{3}.lb(1),p{3}.lb(2),p{3}.ln(1),p{3}.ln(2),p{3}.nob(1),p{3}.nob(2),...
            p{3}.name,p{3}.color(1), p{3}.color(2),p{3}.color(3),...
            p{3}.tropism(1),p{3}.tropism(2),p{3}.tropism(3),...
            p{3}.dx(1), p{3}.rlt(1),p{3}.rlt(2),p{3}.gf(1),sstr);
    end
    
    if get(h.checkbox7,'Value')==1 % Basal
        if isempty(p{4}.successor)
            sstr = '[]';
        else
            sstr = ['[', num2str(p{4}.successor(1)), ', 1]'];
        end
        fprintf(fid,basal,p{4}.r(1),p{4}.r(2),p{4}.a(1),p{4}.a(2),...
            p{4}.theta(1),p{4}.theta(2),p{4}.lb(1),p{4}.lb(2), p{4}.la(1),...
            p{4}.la(2), p{4}.ln(1), p{4}.ln(2),p{4}.nob(1), p{4}.nob(2),...
            p{4}.name,p{4}.color(1), p{4}.color(2),p{4}.color(3),...
            p{4}.tropism(1),p{4}.tropism(2),p{4}.tropism(3),...
            p{4}.dx(1), p{4}.rlt(1),p{4}.rlt(2),p{4}.gf(1),sstr);
    end    
    
    h.firstB = [h.firstB,0]; % in case of no sd add 0
    h.delayB = [h.delayB,0];
    fprintf(fid,dicot,h.plantingdepth,h.firstB(1),h.firstB(2),h.delayB(1),h.delayB(2),h.maxB);
    fprintf(fid,simDicot,h.simtime,h.simtime/(h.intermediate+1));    
    fprintf(fid,viz);        
    fprintf(fid,example);
    fclose(fid);
    
end




% SIMULATE
% --- Executes on button press in pushbutton8.
function pushbutton8_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

h = handles;

% define successors
p = h.parameters;
[h,p] = setSuccessors(h,p);

% Simulation
completeParameters(p);
simtime = h.simtime;
steps = h.intermediate+1; 
str0 = createDicotRS(h.plantingdepth,h.firstB,h.delayB,h.maxB);
wh = waitbar(0,'Simulation...');
for i = 1 : steps
    if i==1 
        str{i} = applyRules(str0,simtime/steps);
    else
        str{i} = applyRules(str{i-1},simtime/steps);
    end
    waitbar(i/steps,wh)    
end
close(wh);
pause(0.1); % no idea why i need this

assignin('base','str',str);
assignin('base','simtime',(simtime/steps).*(1:steps));

% viewer GUI
viewerUI(str,simtime);



% simtime
function edit2_Callback(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

simtime = str2double(get(hObject,'String'));
simtime = min(max(simtime,1),365);
set(hObject,'String',num2str(simtime));
handles.simtime = simtime;
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% intermediate
function edit3_Callback(hObject, eventdata, handles)
% hObject    handle to edit3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit3 as text
%        str2double(get(hObject,'String')) returns contents of edit3 as a double

ir = str2double(get(hObject,'String'));
ir = min(max(ir,0),1e3);
set(hObject,'String',num2str(ir));
handles.intermediate = ir;
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% planting depth
function edit4_Callback(hObject, eventdata, handles)
% hObject    handle to edit4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit4 as text
%        str2double(get(hObject,'String')) returns contents of edit4 as a double

depth = str2double(get(hObject,'String'));
depth = min(max(depth,0),20);
set(hObject,'String',num2str(depth));
handles.plantingdepth = depth;
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function [h,p]=setSuccessors(h,p)
% set successors in dependence of the checkboxes
if get(h.checkbox5,'Value') % laterals
    p{1}.successor = 2;
    p{4}.successor = 2;
else
    p{1}.successor = [];
    p{4}.successor = [];
end
if get(h.checkbox6,'Value') % 2nd order laterals
    p{2}.successor = 3;
    p{3}.successor = [];
end   
if get(h.checkbox7,'Value') % basal roots
    if get(h.checkbox9,'Value') % basal == tap
        p{4} = p{1};
        p{4}.name = 'Basal root';
        p{4}.tropism = [1,0,0.2];
        p{4}.theta = 80/180*pi;
        p{4}.color = [1,0,1];
    end
else
    h.firstB = [Inf,0]; % never 
end


% OPEN
% --------------------------------------------------------------------
function uipushtool1_ClickedCallback(hObject, eventdata, handles)
% hObject    handle to uipushtool1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

h = handles;

[filename, pathname] = uigetfile('*.mat', 'Select root system');
if ~isequal(filename,0) % not cancel
    
    load(fullfile(pathname, filename));
    if exist('parameters') % flexible
        h.parameters = parameters;
    elseif exist('parameter')
        h.parameters = parameter;
    elseif exist('p')
        h.parameters = p;
    end
    
    if exist('dicot')==1
        h.plantingdepth = dicot.plantingdepth;
        h.firstB = dicot.firstB;
        h.delayB = dicot.delayB;
        h.maxB = dicot.maxB;
        h.simtime = dicot.simtime;
        h.intermediate = dicot.intermediate;
        % update gui
        set(h.checkbox5,'Value',dicot.cb(1));
        set(h.checkbox6,'Value',dicot.cb(2));
        set(h.checkbox7,'Value',dicot.cb(3));
        set(h.checkbox9,'Value',dicot.cb(4));
        if length(h.firstB)>1
            set(h.edit10,'String',['[ ',num2str(h.firstB),' ]']);
        else
            set(h.edit10,'String',num2str(h.firstB));
        end
        if length(h.delayB)>1
            set(h.edit11,'String',['[ ',num2str(h.delayB),' ]']);
        else
            set(h.edit11,'String',num2str(h.delayB));
        end
        set(h.edit12,'String',num2str(dicot.maxB));
        set(h.edit4,'String',num2str(dicot.plantingdepth));
        set(h.edit2,'String',num2str(dicot.simtime));
        set(h.edit3,'String',num2str(dicot.intermediate));  
                
    else
        if exist('monocot')==1
            warndlg('Please open in Monocot Plant GUI','Warning','modal');
        else
            warndlg('Dicot plant data is missing','Warning','modal');
        end
    end
        
    guidata(hObject,h);
    checkbox5_Callback(h.checkbox5, [], h);    
    checkbox6_Callback(h.checkbox6, [], h);
    checkbox7_Callback(h.checkbox7, [], h);
    checkbox9_Callback(h.checkbox9, [], h);
    
end


% SAVE
% --------------------------------------------------------------------
function uipushtool2_ClickedCallback(hObject, eventdata, handles)
% hObject    handle to uipushtool2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

h=handles;
[filename, pathname] = uiputfile({'*.mat'},'Save as');
if ~(isequal(filename,0) || isequal(pathname,0)) % not cancel
    
    % root parameters
    parameters = h.parameters;
    
    % additional root system parameters
    dicot.plantingdepth = h.plantingdepth;
    dicot.firstB = h.firstB;
    dicot.delayB = h.delayB;
    dicot.maxB = h.maxB;
    dicot.simtime = h.simtime;
    dicot.intermediate = h.intermediate;        
    dicot.cb = [get(h.checkbox5,'Value'),get(h.checkbox6,'Value'), ... 
        get(h.checkbox7,'Value'),get(h.checkbox9,'Value')]; % checkboxes
    
    % save file
    save(fullfile(pathname,filename),'parameters','dicot');
            
    % copy to workspace
     assignin('base','parameters',parameters);     
     assignin('base','dicot',dicot);   
end









% --- Executes during object creation, after setting all properties.
function figure1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called






function edit10_Callback(hObject, eventdata, handles)
% hObject    handle to edit10 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit10 as text
%        str2double(get(hObject,'String')) returns contents of edit10 as a double

fb = str2num(get(hObject,'String'));
fb = min(max(fb,0),365);
if length(fb)>1
    set(hObject,'String',['[ ',num2str(fb),' ]']);
else
    set(hObject,'String',num2str(fb));    
end
handles.firstB = fb;
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit10_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit10 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit11_Callback(hObject, eventdata, handles)
% hObject    handle to edit11 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit11 as text
%        str2double(get(hObject,'String')) returns contents of edit11 as a double

bd = str2num(get(hObject,'String'));
bd = min(max(bd,0),365);
if length(bd)>1
    set(hObject,'String',['[ ',num2str(bd),' ]']);
else
    set(hObject,'String',num2str(bd));    
end
handles.delayB = bd;
guidata(hObject,handles);



% --- Executes during object creation, after setting all properties.
function edit11_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit11 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit12_Callback(hObject, eventdata, handles)
% hObject    handle to edit12 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

maxB = str2double(get(hObject,'String'));
maxB = min(max(maxB,0),100);
handles.maxB = maxB;
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit12_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit12 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
