%
% This example calculates Fitter parameters of a root system
% (define root system parameters first)
%

% Run simulation
simtime = 15; % days
root = createRootSystem(); 
str = applyRules(root,simtime); 
 

% Fitter parameter
[A, nodes, indS] = getGraph2(str);
[m,epl,al] = getFitter(A);
disp(['Magnitude ', num2str(m)]);
disp(['External path length ', num2str(m)]);
disp(['Altitude ', num2str(al)]);

% Plot including nodes
figure;
hold on;
plotTubes(str);
scatter3(nodes(:,1),nodes(:,2),nodes(:,3));